@section=site guide
@heading=Root Certificate
@header

<!-- This file is preprocessed by cgi/html.cgi -->

<h2>Overview</h2>

<div class="indent">
<p>This site provides https support in order to support the Git smart HTTP
push protocol.</p>

<p>This obviously requires this site to have an SSL server certificate.  In order
to avoid the hassle (and the continual renewal burden) of getting an SSL server
certificate that has been signed by a root certificate already included (and trusted)
by your browser, this site uses its own root certificate.</p>

<p>Git version 1.8.5 and later can quickly and easily be configured (see the
&#x201c;Quick Setup&#x201d; section below) to use this root certificate ONLY
for connections to @@base(httpspushurl)@@.  This configuration is the equivalent
of answering &#x201c;yes&#x201d; to the ssh &#x201c;Are you sure you want to
continue connecting?&#x201d; prompt when you first connect to a new ssh server.</p>

<p>The root certificate for this site (@@base(httpspushurl)@@) is available from:</p>
<div class="indent">
<a href="@@path(webadmurl)@@/@@nickname@@_root_cert.pem">@@server(webadmurl)@@/@@nickname@@_root_cert.pem</a>
<br />
md5: <tt>@@md5(@@nickname@@_root_cert.pem)@@</tt>
<br />
sha1: <tt>@@sha1(@@nickname@@_root_cert.pem)@@</tt>
<br />
blob: <tt>@@blob(@@nickname@@_root_cert.pem)@@</tt>
</div>

<p>See also the <a href="@@path(htmlurl)@@/httpspush.html">full instructions on configuring your Git client for https push</a>.</p>
@@ifmob@@
<p>For information on how to push to the mob branch using https see <a href="@@path(htmlurl)@@/mob.html#httpsmobpush">here</a>.</p>
@@end@@
</div>

<h2 id="quick">Quick Setup</h2>
<div class="indent">
<p>These instructions require Git version 1.8.5 or later.</p>
<p>The following shell commands (which can be copied and pasted into a terminal window)
will download the root certificate to <tt>~/certs/@@nickname@@_root_cert.pem</tt>
using <tt>curl</tt> and then configure Git to use it ONLY for connections to @@base(httpspushurl)@@.</p>
<pre class="indent">
mkdir -p ~/certs
cd ~/certs
curl -kO @@base(httpspushurl)@@/@@nickname@@_root_cert.pem
git config --global http.@@base(httpspushurl)@@.sslCAInfo \
  ~/certs/@@nickname@@_root_cert.pem
git hash-object --no-filters ~/certs/@@nickname@@_root_cert.pem
</pre>
<p>Verify that the hash value output by <tt>git hash-object</tt> matches
the &#x201c;blob:&#x201d; hash value shown at the top of this page.</p>
</div>

<h2 id="details">Details</h2>
<div class="indent">
<p>A side effect of using an unrecognized root certificate is that Git may
complain with an error such as:</p>
<blockquote>
<tt>error: server certificate verification failed</tt>
</blockquote>

<p>To see this error in action, simply execute this git command:</p>
<blockquote><pre>
git ls-remote @@httpspushurl@@/girocco.git
</pre></blockquote>

<p>Instead of downloading the server&#x2019;s root certificate, server certificate verification may be disabled with one of these techniques:</p>

<ol>
<li>Set the <tt>GIT_SSL_NO_VERIFY</tt> environment variable like so:
<pre>
GIT_SSL_NO_VERIFY=1 git ls-remote @@httpspushurl@@/girocco.git
</pre></li>

<li>Temporarily set the git configuration variable <tt>http.sslVerify</tt> like so:
<pre>
git -c http.sslVerify=false \
ls-remote @@httpspushurl@@/girocco.git
</pre>
<p>Note that the <tt>-c</tt> option requires Git version 1.7.2 or later.</p></li>
</ol>

<p>Or, after downloading the root certificate for this site, the error may be
avoided through various methods by specifying the root certificate.<br />
For each of these methods, the root certificate will be assumed to be downloaded
and saved to the file <tt>$HOME/certs/@@nickname@@_root_cert.pem</tt>.</p>

<p id="git185">Using Git version 1.8.5 or later (recommended):</p>

<ol>
<li>Configure the global <tt>http.sslCAInfo</tt> variable but only for this site like so:
<pre>
git config --global http.@@base(httpspushurl)@@.sslCAInfo \
                    $HOME/certs/@@nickname@@_root_cert.pem
</pre>
<p>Note that this technique requires Git version 1.8.5 or later on the client but has the advantage of only needing to be done once.</p></li>
</ol>

<p>Using any version of Git:</p>

<ol start="2">
<li>Set the <tt>GIT_SSL_CAINFO</tt> environment variable before running git like so:
<pre>
GIT_SSL_CAINFO=$HOME/certs/@@nickname@@_root_cert.pem \
git ls-remote @@httpspushurl@@/girocco.git
</pre></li>

<li>Temporarily set the git configuration variable <tt>http.sslCAInfo</tt> like so:
<pre>
git -c http.sslCAInfo=$HOME/certs/@@nickname@@_root_cert.pem \
ls-remote @@httpspushurl@@/girocco.git
</pre></li>

<li>Configure the git <tt>http.sslCAInfo</tt> variable like so:
<pre>
git config http.sslCAInfo $HOME/certs/@@nickname@@_root_cert.pem
</pre>
<p>Note that this technique works best after the repository has already been cloned
or initialized.</p></li>
</ol>

<p>For further details see the <tt>git help config</tt> output.</p>
</div>
